/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.readers.GaussianCubeReader;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.swingwrappers.TextField;
import static org.visnow.vn.lib.basic.readers.GaussianCubeReader.GaussianCubeShared.*;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private JFileChooser dataFileChooser = new JFileChooser();
    private FileNameExtensionFilter dataFilter;
    private Parameters parameters;
    private String lastPath = null;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    public GUI(String title, String dataFileDesc, String ext0, String ext1)
    {
        initComponents();
        dataFileChooser.setLocation(0, 0);
        moduleLabel.setText(title);
        dataFilter = new FileNameExtensionFilter(dataFileDesc, ext0, ext1);
        dataFileChooser.setFileFilter(dataFilter);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        selectButton = new javax.swing.JButton();
        moduleLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        fileNameField = new org.visnow.vn.gui.swingwrappers.TextField();

        setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        setMinimumSize(new java.awt.Dimension(180, 500));
        setOpaque(false);
        setPreferredSize(new java.awt.Dimension(200, 600));
        setRequestFocusEnabled(false);
        setLayout(new java.awt.GridBagLayout());

        selectButton.setText("Browse...");
        selectButton.setMaximumSize(new java.awt.Dimension(102, 20));
        selectButton.setMinimumSize(new java.awt.Dimension(102, 20));
        selectButton.setPreferredSize(new java.awt.Dimension(102, 20));
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(selectButton, gridBagConstraints);

        moduleLabel.setText("module");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(moduleLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        fileNameField.setSubmitOnLostFocus(false);
        fileNameField.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                fileNameFieldUserAction(evt);
            }
        });
        fileNameField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                fileNameFieldFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(fileNameField, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        String fileName = null;
        if (lastPath == null)
            dataFileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(GaussianCubeReader.class)));
        else
            dataFileChooser.setCurrentDirectory(new File(lastPath));

        int returnVal = dataFileChooser.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            fileName = dataFileChooser.getSelectedFile().getAbsolutePath();
            lastPath = fileName.substring(0, fileName.lastIndexOf(File.separator));
            VisNow.get().getMainConfig().setLastDataPath(lastPath, GaussianCubeReader.class);
            parameters.set(FILENAME, fileName);
        }
    }//GEN-LAST:event_selectButtonActionPerformed

    private void fileNameFieldUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_fileNameFieldUserAction
        if (evt.getEventType() == TextField.EVENT_CHANGE_VALUE || evt.getEventType() == TextField.EVENT_NO_CHANGE_ENTER_KEY)
            parameters.set(FILENAME, fileNameField.getText());
    }//GEN-LAST:event_fileNameFieldUserAction

    private void fileNameFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_fileNameFieldFocusGained
        ((TextField) evt.getSource()).selectAll();
    }//GEN-LAST:event_fileNameFieldFocusGained


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.swingwrappers.TextField fileNameField;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel moduleLabel;
    private javax.swing.JButton selectButton;
    // End of variables declaration//GEN-END:variables
    /**
     * @param params the params to set
     */
    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }
    
     void updateGUI(ParameterProxy p)
    {
        fileNameField.setText(p.get(FILENAME));
    }

    public String getLastPath()
    {
        return lastPath;
    }

    public void activateOpenDialog()
    {
        selectButtonActionPerformed(null);
    }

}
